require "./test/test_helper"

class ConfgurationTest < MiniTest::Unit::TestCase
  def test_configured_returns_false_when_not_configured
    ConfigHelper.reset
    assert_equal(false, Reelagram::Mail.configured?)
  end

  def test_confiures_the_email_address
    ConfigHelper.confgure_mail
    assert_equal(Reelagram::Mail.configuration.email, "foo@example.com")
  end

  def test_confiures_the_password
    ConfigHelper.confgure_mail
    assert_equal(Reelagram::Mail.configuration.password, "zomgLOLZ")
  end

  def test_when_configured_returns_true_for_configured?
    ConfigHelper.confgure_mail
    assert(Reelagram::Mail.configured?)
  end

  def test_when_not_configured_returns_false_for_configured?
    ConfigHelper.reset
    refute(Reelagram::Mail.configured?)
  end

  def test_configuration_returns_true
    assert_equal(true, ConfigHelper.confgure_mail)
  end

  def test_configure_with_debug_mode
    ConfigHelper.confgure_mail
    Reelagram::Mail.configuration.debug = true
    assert(Reelagram::Mail.debug?)
  end
end
