require "./test/test_helper"

class ShippingUpdateProcessorTest < MiniTest::Unit::TestCase
  attr_reader :processor, :parser

  def test_run_returns_an_array
    assert_kind_of(Array, processor.run)
  end

  def test_run_returns_an_empty_array_when_there_is_no_data
    process_nothing = Reelagram::Mail::Processors::ShippingProcessor.new([], parser)
    assert_equal([], process_nothing.run)
  end

  def test_run_returns_the_parsed_data_from_the_email
    parsed_data = {
      order_id:        "7780000298",
      carrier:         "United States Postal Service",
      tracking_number: "92789999982943513015003089",
      tracking_link:   "http://wwwapps.ups.com/WebTracking/track?HTMLVersion=5.0&loc=en_US&Requester=UPSHome&WBPM_lid=homepage%2Fct1.html_pnl_trk&trackNums=92789999982943513015003089&track.x=Track target="
    }
    assert_equal([parsed_data], processor.run)
  end

  def parser
    @parser ||= Reelagram::Mail::Parsers::ShippingParser.new
  end

  def processor
    @processor ||= Reelagram::Mail::Processors::ShippingProcessor.new(email_data, parser)
  end

  def email_data
    [{ body: FixtureHelper.fixture("email_body.txt") }]
  end
end

